package com.alterdekim.flash.decompiler.tag;

import com.alterdekim.flash.decompiler.compiler.CompileObject;
import com.alterdekim.flash.decompiler.util.ByteUtil;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.ToString;

import java.util.BitSet;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@ToString
@Getter
@AllArgsConstructor
public class SetBackgroundColor extends ShockwaveTag implements CompileObject {

    private byte[] backgroundColor;

    @Override
    public TagType getType() {
        return TagType.SetBackgroundColor;
    }

    @Override
    public List<Byte> compile() {
        int val = getType().getId() << 6;
        val |= 3;
        return Stream.of(ByteUtil.intToBytes(val), ByteUtil.fromPrimitive(backgroundColor)).flatMap(Collection::stream).collect(Collectors.toList());
    }
}

